#include <stdio.h>
#define BUFSIZE 1024

int main(argc,argv)
int argc;
char *argv[];
{  FILE *fpi,*fpo;
	 unsigned char *buffer,*buffptr;
	 int rd,i,j;
	 unsigned int address;
	 long filesize;

   if (argc<3) {
     fputs("usage: dbgconv input-filename output-filename\n",stderr);
     fputs("       (c)2001 Peter Dassow, royalty free software.\n",stderr);
     fputs("       This program converts a binary file to a text file\n",stderr);
     fputs("       which can be saved with DEBUG back to a binary file.\n\n",stderr);
     fputs("       Example: DEBUG < output-filename      (will save the file back)\n",stderr);
     exit(1);
   }
   address=0x100;

   fpi=fopen(argv[1],"rb"); /* binary ! */
   if (fpi==NULL) {
     fputs("Input file error\n",stderr);
     exit(2);
   }
   fpo=fopen(argv[2],"w"); /* just text */
   if (fpo==NULL) {
     fputs("Output file error\n",stderr);
     exit(2);
   }

   buffer=malloc(BUFSIZE);
   if (buffer==NULL) {
     fprintf(stderr,"Can't allocate %d bytes\n",BUFSIZE);
     exit(3);
   }
   fseek(fpi,0L,SEEK_END);
   filesize = ftell(fpi);
   fseek(fpi,0L,SEEK_SET);
   if (filesize>65535L) {
     fputs("Sorry, files larger than 64KB can't be processed\n",stderr);
     exit(4);
   }
   fprintf(fpo,"rcx\n%04x\n",filesize);

   fprintf(fpo,"n%s\n",argv[1]);

   rd=fread(buffer,1,BUFSIZE,fpi);
   while (rd>0) {
   	 buffptr=buffer;
   	 j=1;
   	 for (i=0;i<rd;i++) {
   	 	 if (j==1) {
   	 	 	fprintf(fpo,"e%04x ",address);
   	   }
   	   fprintf(fpo,"%02x",*buffptr);
   	   j++;
   	   if (j>16) {
   	   	fputc('\n',fpo);
   	   	j=1;
   	   	address+=16;
   	   }
   	   else {
   	   	fputc(' ',fpo);
   	   }
   	   buffptr++;
     }
     rd=fread(buffer,1,BUFSIZE,fpi);
   }
   fputs("\nw\nq\n",fpo);
   
   fclose(fpi);
   fclose(fpo);

}
